; -----------------------------------------------------------------------------
;	XvCg\XV
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"

		.globl	score_update
		.globl	score_update_high_score
		.globl	player_speed
		.globl	player_shot
		.globl	player_shield

		.area	CODE (ABS)

; -----------------------------------------------------------------------------
;	OtBbNp^[`
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
background_init::
		; STAGEԍ
		ld		a, #02		; STAGE1
		ld		(background_str_stage_number), a
		; p^[l[e[uNA
		ld		hl, #PATTERN_NAME1
		ld		bc, #768
		xor		a
		call	FILVRM
		; p^[WFl[^[e[uɃp^[]
		ld		hl, #background_pattern
		ld		de, #PATTERN_GENERATOR1
		ld		bc, #(background_pattern_end - background_pattern)
		call	LDIRVM
		ld		hl, #background_pattern
		ld		de, #PATTERN_GENERATOR2
		ld		bc, #(background_pattern_end - background_pattern)
		call	LDIRVM
		ld		hl, #background_pattern
		ld		de, #PATTERN_GENERATOR3
		ld		bc, #(background_pattern_end - background_pattern)
		call	LDIRVM
		; J[e[uɃJ[]
		ld		de, #COLOR_TABLE1
		call	background_set_color
		ld		de, #COLOR_TABLE2
		call	background_set_color
		ld		de, #COLOR_TABLE3
		call	background_set_color
		; J[e[u2 (wi)
		ld		hl, #(COLOR_TABLE1 + 64*8)
		ld		bc, #(4*4*8)
		ld		a, #0x2C
		call	FILVRM
		ld		hl, #(COLOR_TABLE2 + 64*8)
		ld		bc, #(4*4*8)
		ld		a, #0x2C
		call	FILVRM
		ld		hl, #(COLOR_TABLE3 + 64*8)
		ld		bc, #(4*4*8)
		ld		a, #0x2C
		call	FILVRM
		ret
		; J[e[u ()
background_set_color:
		xor		a
		ld		bc, #8
background_set_color_loop:
		push	af
		push	de
		push	bc
		ld		hl, #background_color
		call	LDIRVM
		pop		bc
		pop		de
		pop		af
		ex		de, hl
		add		hl, bc
		ex		de, hl
		dec		a
		jr		nz, background_set_color_loop
		ret

; -----------------------------------------------------------------------------
;	Q[ʂ̕\
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
background_init_game_screen::
		; XN[JE^[
		xor		a
		ld		(background_scroll_timing), a
		ld		(background_scroll_counter), a
		; EXRA\̈Xy[XŖߐs
		ld		hl, #(PATTERN_NAME1 + 24)				; locate 24,0
		ld		bc, #8									;  8
		ld		e, #24									; 24C
background_init_score_area_loop1:
		push	de
		push	bc
		xor		a										; Xy[X̕R[h 0
		call	FILVRM									; 0 œhԂ
		pop		bc
		ld		de, #32									; ̃Cւ̃ItZbg
		add		hl, de
		pop		de
		dec		e
		jr		nz, background_init_score_area_loop1
background_init_put_score:
		; "HISCORE" \
		ld		hl, #background_str_hiscore
		ld		de, #(PATTERN_NAME1 + 24 + 32*1)		; locate 24,1
		ld		bc, #7
		call	LDIRVM
		; "SCORE" \
		ld		hl, #background_str_score
		ld		de, #(PATTERN_NAME1 + 24 + 32*5)		; locate 24,5
		ld		bc, #5
		call	LDIRVM
		; XRA\XV
		call	score_update_high_score
		call	score_update
		; @\XV
		call	background_update_player_info
background_init_field:
		; tB[hiXRA\ȊO̕j
		ld		c, #VDP_VRAM_IO
		ld		hl, #PATTERN_NAME1
		ld		de, #0
		ld		b, #24									; 24C
background_init_field_loop2:
		push	bc
		call	SETWRT
		ld		b, #24									;  24
		ld		d, #0
background_init_field_loop1:
		ld		a, d
		and		#3										; a ɂ 0`3 ̂ǂꂩ
		rlca											; a = a * 4
		rlca											; sla a ł͂Ȃ rlca ɂ̂́Arlca  1byte߂ŏB
		add		a, e									; 0,1,2,3 ̂ǂꂩZ
		add		a, #64									; 64 Z
		out		(c), a
		inc		d
		djnz	background_init_field_loop1
		ld		a, e
		inc		a
		and		#3
		ld		de, #32									; ̃Cւ̃ItZbg
		add		hl, de
		ld		e, a
		pop		bc
		djnz	background_init_field_loop2
		ret

; -----------------------------------------------------------------------------
;	@\
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
background_update_player_info::
		; @W
		ld		a, (player_speed)
		inc		a
		ld		(background_str_speed_num), a
		ld		a, (player_shot)
		inc		a
		ld		(background_str_shot_num), a
		ld		a, (player_shield)
		inc		a
		ld		(background_str_shield_num), a
		; "SPEED x" \
		ld		hl, #background_str_speed
		ld		de, #(PATTERN_NAME1 + 24 + 32*18)		; locate 24,18
		ld		bc, #7
		call	LDIRVM
		; "SHOT  x" \
		ld		hl, #background_str_shot
		ld		de, #(PATTERN_NAME1 + 24 + 32*20)		; locate 24,20
		ld		bc, #7
		call	LDIRVM
		; "SHIELDx" \
		ld		hl, #background_str_shield
		ld		de, #(PATTERN_NAME1 + 24 + 32*22)		; locate 24,22
		ld		bc, #7
		jp		LDIRVM

; -----------------------------------------------------------------------------
;	Q[ʂ̕\
;	input:
;		a	...	Xe[Wԍ (0 = stage1)
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
background_draw_stage_x::
		; "STAGEx" \
		and		#7
		inc		a
		inc		a
		ld		(background_str_stage_number), a
		ld		hl, #background_str_stage
		ld		de, #(PATTERN_NAME1 + 9 + 32*8)			; locate 9,8
		ld		bc, #6
		jp		LDIRVM

; -----------------------------------------------------------------------------
;	Q[ʂ STAGE* ̕\
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
background_delete_stage_message::
		ld		hl, #background_str_stage_back
		ld		de, #(PATTERN_NAME1 + 9 + 32*8)			; locate 9,8
		ld		bc, #6
		jp		LDIRVM

; -----------------------------------------------------------------------------
;	NA
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
background_clear_left_side:
		; tB[hiXRA\ȊO̕j
		ld		c, #VDP_VRAM_IO
		ld		hl, #PATTERN_NAME1
		ld		de, #0
		ld		b, #24									; 24C
background_clear_left_side_loop2:
		push	bc
		call	SETWRT
		ld		b, #24									;  24
		ld		d, #0
		xor		a
background_clear_left_side_loop1:
		out		(c), a
		djnz	background_clear_left_side_loop1
		ld		de, #32									; ̃Cւ̃ItZbg
		add		hl, de
		pop		bc
		djnz	background_clear_left_side_loop2
		ret

; -----------------------------------------------------------------------------
;	Q[NAʂ̏
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
background_init_stage_clear_screen::
		; NA
		call	background_clear_left_side
		; STAGE CLEAR! \
		ld		hl, #background_str_stage_clear
		ld		de, #(PATTERN_NAME1 + 6 + 32*5)			; locate 6,5
		ld		bc, #12
		call	LDIRVM
		; CLEAR BONUS 10000 \
		ld		hl, #background_str_clear_bonus
		ld		de, #(PATTERN_NAME1 + 3 + 32*11)		; locate 3,11
		ld		bc, #17
		jp		LDIRVM

; -----------------------------------------------------------------------------
;	Q[I[o[ʂ̏
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
background_init_gameover_screen::
		; NA
		call	background_clear_left_side
		; GAMEOVER \
		ld		hl, #background_str_gameover
		ld		de, #(PATTERN_NAME1 + 8 + 32*10)		; locate 8,10
		ld		bc, #9
		jp		LDIRVM

; -----------------------------------------------------------------------------
;	wĩXN[
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
background_scroll::
		; XN[^C~OH
		ld		a, (background_scroll_timing)
		dec		a
		and		#3
		ld		(background_scroll_timing), a		; tOs
		; 0 ̂Ƃ̓Vtgʂ֑Jڂ
		jr		z, background_scroll_next
		; 1 ̎ PATTERN_GENERATOR1 XV
		ld		hl, #(PATTERN_GENERATOR1+64*8)
		dec		a
		jr		z, background_scroll_skip1
		; 2 ̎ PATTERN_GENERATOR2 XV
		ld		hl, #(PATTERN_GENERATOR2+64*8)
		dec		a
		jr		z, background_scroll_skip1
		; 3 ̎ PATTERN_GENERATOR2 XV
		ld		hl, #(PATTERN_GENERATOR3+64*8)
		; XN[
background_scroll_skip1:
		call	SETWRT
		ld		de, #background_graphic01_00
		ld		(background_scroll_pat_adr), de
		ld		de, #(4*8)							; 1̌`byte
		ld		b, #4								; 40̗A44̗A48̗A52̗̂S
background_scroll_loop2:
		exx

		ld		a, (background_scroll_counter)
		ld		b, #32								; 1 32byte
		ld		c, #VDP_VRAM_IO
background_scroll_loop1:
		ld		hl, (background_scroll_pat_adr)
		ld		e, a
		ld		d, #0
		add		hl, de
		inc		a
		and		#31
		ld		e, (hl)
		out		(c), e
		djnz	background_scroll_loop1

		ld		hl, (background_scroll_pat_adr)
		ld		de, #32
		add		hl, de
		ld		(background_scroll_pat_adr), hl

		exx
		add		hl, de
		djnz	background_scroll_loop2
		ret
background_scroll_next:
		; XN[
		ld		a, (background_scroll_counter)
		dec		a
		and		#31
		ld		(background_scroll_counter), a
		ret

		; AhXێp[N
background_scroll_pat_adr:
		.dw		#0
		; XN[JE^
background_scroll_timing:
		.db		#0									; 0`3, fNgJE^
background_scroll_counter:
		.db		#0									; 0`31, fNgJE^
		; "HI"
background_str_hiscore:
		.db		#18, #19
		; "SCORE"
background_str_score:
		.db		#29, #13, #25, #28, #15
		; "SPEED x"
background_str_speed:
		.db		#29, #26, #15, #15, #14, #0
background_str_speed_num:
		.db		#1									; SPEEDԍ + 1
		; "SHOT  x"
background_str_shot:
		.db		#29, #18, #25, #30, #0 , #0
background_str_shot_num:
		.db		#1									; SHOTԍ + 1
		; "SHIELDx"
background_str_shield:
		.db		#29, #18, #19, #15, #22, #14
background_str_shield_num:
		.db		#1									; SHIELDԍ + 1
		; "STAGE"
background_str_stage:
		.db		#29, #30, #11, #17, #15
background_str_stage_number:
		.db		#02									; STAGEԍ + 1
		; "STAGE" ̈ʒu̔wi
background_str_stage_back:
		.db		#68, #72, #76, #64, #68, #72
		; "STAGE CLEAR!"
background_str_stage_clear:
		.db		#29, #30, #11, #17, #15, #0 , #13, #22, #15, #11, #28, #37
		; "CLEAR BONUS 10000"
background_str_clear_bonus:
		.db		#13, #22, #15, #11, #28, #0 , #12, #25, #24, #31, #29, #0
		.db		#2 , #1 , #1 , #1 , #1 
		; "GAME OVER"
background_str_gameover:
		.db		#17, #11, #23, #15, #0 , #25, #32, #15, #28
		; wiOtBbN
background_graphic01_00:
		.db		#0x83
		.db		#0xBC
		.db		#0x7F
		.db		#0x7F
		.db		#0x7F
		.db		#0x3E
		.db		#0x00
		.db		#0x5D
		.db		#0x1E
		.db		#0x84
		.db		#0xE0
		.db		#0xEF
		.db		#0x07
		.db		#0x60
		.db		#0x0F
		.db		#0x3F
		.db		#0xDF
		.db		#0xEA
		.db		#0xC0
		.db		#0x3B
		.db		#0x79
		.db		#0x7B
		.db		#0x79
		.db		#0x74
		.db		#0x0A
		.db		#0xE5
		.db		#0xE3
		.db		#0xCC
		.db		#0x1F
		.db		#0x3F
		.db		#0x1F
		.db		#0x0F

background_graphic01_01:
		.db		#0xDF
		.db		#0x20
		.db		#0x73
		.db		#0x78
		.db		#0x19
		.db		#0x40
		.db		#0xEB
		.db		#0xD7
		.db		#0x03
		.db		#0x3C
		.db		#0xD8
		.db		#0xE7
		.db		#0xCF
		.db		#0x0F
		.db		#0x03
		.db		#0xE0
		.db		#0xEE
		.db		#0x87
		.db		#0x1A
		.db		#0x40
		.db		#0xC1
		.db		#0xE7
		.db		#0x91
		.db		#0x00
		.db		#0xE5
		.db		#0xF8
		.db		#0xFB
		.db		#0xE7
		.db		#0x07
		.db		#0xC0
		.db		#0xEE
		.db		#0xDF

background_graphic01_02:
		.db		#0x8F
		.db		#0x33
		.db		#0xF8
		.db		#0xFE
		.db		#0x58
		.db		#0x00
		.db		#0x99
		.db		#0xDB
		.db		#0x93
		.db		#0x01
		.db		#0x7C
		.db		#0x1F
		.db		#0xCF
		.db		#0xC0
		.db		#0x1C
		.db		#0x30
		.db		#0x87
		.db		#0xCF
		.db		#0x8F
		.db		#0x06
		.db		#0xE0
		.db		#0xF8
		.db		#0xE0
		.db		#0x07
		.db		#0x4F
		.db		#0x0F
		.db		#0xC1
		.db		#0xF8
		.db		#0xFC
		.db		#0xF3
		.db		#0x01
		.db		#0x9E

background_graphic01_03:
		.db		#0xE7
		.db		#0x83
		.db		#0x30
		.db		#0x78
		.db		#0x78
		.db		#0x30
		.db		#0x84
		.db		#0xE6
		.db		#0xE7
		.db		#0xC7
		.db		#0x17
		.db		#0xAF
		.db		#0x02
		.db		#0x78
		.db		#0xF0
		.db		#0x70
		.db		#0x07
		.db		#0xD7
		.db		#0xA0
		.db		#0x03
		.db		#0xF3
		.db		#0xF7
		.db		#0x77
		.db		#0x34
		.db		#0xC0
		.db		#0xC1
		.db		#0x87
		.db		#0x07
		.db		#0x70
		.db		#0xF8
		.db		#0xE3
		.db		#0x07

		; tHg
background_pattern:
		.db		#0x00
		.db		#0x00
		.db		#0x00
		.db		#0x00
		.db		#0x00
		.db		#0x00
		.db		#0x00
		.db		#0x00

		.db		#0x7C
		.db		#0xFE
		.db		#0xC6
		.db		#0xC6
		.db		#0xC6
		.db		#0xFE
		.db		#0x7C
		.db		#0x00

		.db		#0x38
		.db		#0x38
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x00

		.db		#0xFC
		.db		#0xFE
		.db		#0x06
		.db		#0x7C
		.db		#0xC0
		.db		#0xFE
		.db		#0xFE
		.db		#0x00

		.db		#0xFC
		.db		#0xFE
		.db		#0x06
		.db		#0x7C
		.db		#0x06
		.db		#0xFE
		.db		#0xFC
		.db		#0x00

		.db		#0x3C
		.db		#0x7C
		.db		#0xEC
		.db		#0xCC
		.db		#0xFE
		.db		#0xFE
		.db		#0x0C
		.db		#0x00

		.db		#0xFE
		.db		#0xFE
		.db		#0xC0
		.db		#0xFC
		.db		#0x06
		.db		#0xFE
		.db		#0xFC
		.db		#0x00

		.db		#0x3C
		.db		#0x7C
		.db		#0xC0
		.db		#0xFC
		.db		#0xC6
		.db		#0xFE
		.db		#0x7C
		.db		#0x00

		.db		#0xFE
		.db		#0xFE
		.db		#0xCC
		.db		#0x0C
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x00

		.db		#0x7C
		.db		#0xFE
		.db		#0xC6
		.db		#0x7C
		.db		#0xC6
		.db		#0xFE
		.db		#0x7C
		.db		#0x00

		.db		#0x7C
		.db		#0xFE
		.db		#0xC6
		.db		#0x7E
		.db		#0x06
		.db		#0x7C
		.db		#0x78
		.db		#0x00

		.db		#0x7C
		.db		#0xFE
		.db		#0xC6
		.db		#0xC6
		.db		#0xFE
		.db		#0xFE
		.db		#0xC6
		.db		#0x00

		.db		#0xFC
		.db		#0xFE
		.db		#0xC6
		.db		#0xFC
		.db		#0xC6
		.db		#0xFE
		.db		#0xFC
		.db		#0x00

		.db		#0x7C
		.db		#0xFC
		.db		#0xC0
		.db		#0xC0
		.db		#0xC0
		.db		#0xFC
		.db		#0x7C
		.db		#0x00

		.db		#0xF8
		.db		#0xFC
		.db		#0xCE
		.db		#0xC6
		.db		#0xCE
		.db		#0xFC
		.db		#0xF8
		.db		#0x00

		.db		#0xFE
		.db		#0xFE
		.db		#0xC0
		.db		#0xFC
		.db		#0xC0
		.db		#0xFE
		.db		#0xFE
		.db		#0x00

		.db		#0xFE
		.db		#0xFE
		.db		#0xC0
		.db		#0xFC
		.db		#0xFC
		.db		#0xC0
		.db		#0xC0
		.db		#0x00

		.db		#0x7C
		.db		#0xFC
		.db		#0xC0
		.db		#0xDE
		.db		#0xC6
		.db		#0xFE
		.db		#0x7C
		.db		#0x00

		.db		#0xC6
		.db		#0xC6
		.db		#0xC6
		.db		#0xFE
		.db		#0xC6
		.db		#0xC6
		.db		#0xC6
		.db		#0x00

		.db		#0x3C
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x3C
		.db		#0x3C
		.db		#0x00

		.db		#0x1E
		.db		#0x0C
		.db		#0x0C
		.db		#0x0C
		.db		#0xCC
		.db		#0xFC
		.db		#0x78
		.db		#0x00

		.db		#0xCE
		.db		#0xDC
		.db		#0xF8
		.db		#0xF8
		.db		#0xDC
		.db		#0xCE
		.db		#0xC6
		.db		#0x00

		.db		#0xC0
		.db		#0xC0
		.db		#0xC0
		.db		#0xC0
		.db		#0xC0
		.db		#0xFE
		.db		#0xFE
		.db		#0x00

		.db		#0xC6
		.db		#0xEE
		.db		#0xFE
		.db		#0xD6
		.db		#0xC6
		.db		#0xC6
		.db		#0xC6
		.db		#0x00

		.db		#0xE6
		.db		#0xE6
		.db		#0xF6
		.db		#0xD6
		.db		#0xDE
		.db		#0xCE
		.db		#0xCE
		.db		#0x00

		.db		#0x7C
		.db		#0xFE
		.db		#0xC6
		.db		#0xC6
		.db		#0xC6
		.db		#0xFE
		.db		#0x7C
		.db		#0x00

		.db		#0xFC
		.db		#0xFE
		.db		#0xC6
		.db		#0xFE
		.db		#0xFC
		.db		#0xC0
		.db		#0xC0
		.db		#0x00

		.db		#0x7C
		.db		#0xFE
		.db		#0xC6
		.db		#0xC6
		.db		#0xDE
		.db		#0xFC
		.db		#0x7A
		.db		#0x00

		.db		#0xFC
		.db		#0xFE
		.db		#0xC6
		.db		#0xFE
		.db		#0xFC
		.db		#0xDE
		.db		#0xCE
		.db		#0x00

		.db		#0x7C
		.db		#0xFC
		.db		#0xC0
		.db		#0x7C
		.db		#0x06
		.db		#0xFE
		.db		#0xFC
		.db		#0x00

		.db		#0x7E
		.db		#0x7E
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x00

		.db		#0xC6
		.db		#0xC6
		.db		#0xC6
		.db		#0xC6
		.db		#0xC6
		.db		#0xFE
		.db		#0x7C
		.db		#0x00

		.db		#0xC6
		.db		#0xC6
		.db		#0x6C
		.db		#0x6C
		.db		#0x38
		.db		#0x38
		.db		#0x10
		.db		#0x00

		.db		#0xC6
		.db		#0xC6
		.db		#0xC6
		.db		#0xD6
		.db		#0xFE
		.db		#0xEE
		.db		#0xC6
		.db		#0x00

		.db		#0xC6
		.db		#0xC6
		.db		#0x6C
		.db		#0x38
		.db		#0x6C
		.db		#0xC6
		.db		#0xC6
		.db		#0x00

		.db		#0x66
		.db		#0x66
		.db		#0x7E
		.db		#0x3C
		.db		#0x18
		.db		#0x18
		.db		#0x18
		.db		#0x00

		.db		#0xFE
		.db		#0xFE
		.db		#0x1C
		.db		#0x38
		.db		#0x70
		.db		#0xFE
		.db		#0xFE
		.db		#0x00

		.db		#0x10
		.db		#0x38
		.db		#0x38
		.db		#0x38
		.db		#0x10
		.db		#0x00
		.db		#0x10
		.db		#0x00

		.db		#0xFF
		.db		#0xFF
		.db		#0xFF
		.db		#0xFF
		.db		#0xFF
		.db		#0xFF
		.db		#0xFF
		.db		#0xFF

		.db		#0x38
		.db		#0x44
		.db		#0xBA
		.db		#0xA2
		.db		#0xBA
		.db		#0x44
		.db		#0x38
		.db		#0x00

		.db		#0x10
		.db		#0x10
		.db		#0x28
		.db		#0xAA
		.db		#0xFE
		.db		#0xFE
		.db		#0xBA
		.db		#0x00

		.db		#0x03
		.db		#0x0F
		.db		#0x1F
		.db		#0x3F
		.db		#0x7F
		.db		#0x7F
		.db		#0xFF
		.db		#0xFF

		.db		#0xC0
		.db		#0xF0
		.db		#0xF8
		.db		#0xFC
		.db		#0xFE
		.db		#0xFE
		.db		#0xFF
		.db		#0xFF

		.db		#0xFF
		.db		#0xFF
		.db		#0x7F
		.db		#0x7F
		.db		#0x3F
		.db		#0x1F
		.db		#0x0F
		.db		#0x03

		.db		#0xFF
		.db		#0xFF
		.db		#0xFE
		.db		#0xFE
		.db		#0xFC
		.db		#0xF8
		.db		#0xF0
		.db		#0xC0

		.db		#0xFE		; O
		.db		#0x00
		.db		#0x00
		.db		#0x7C
		.db		#0x00
		.db		#0x00
		.db		#0xFE
		.db		#0x00

		.db		#0x1C		; 
		.db		#0xE0
		.db		#0x3C
		.db		#0xE0
		.db		#0x3E
		.db		#0xE0
		.db		#0x1E
		.db		#0x00

		.db		#0xE8		; 
		.db		#0x48
		.db		#0xE8
		.db		#0x48
		.db		#0xE8
		.db		#0xAA
		.db		#0xE6
		.db		#0x00

		.db		#0x05		; WF
		.db		#0xC5
		.db		#0x00
		.db		#0xC4
		.db		#0x08
		.db		#0x13
		.db		#0xE1
		.db		#0x03

		.db		#0x00		; 
		.db		#0x7E
		.db		#0x42
		.db		#0x42
		.db		#0x42
		.db		#0xC2
		.db		#0x7E
		.db		#0x80
background_pattern_end:

background_color:
		.db		#0xF0
		.db		#0xF0
		.db		#0x70
		.db		#0x70
		.db		#0x50
		.db		#0x50
		.db		#0x40
		.db		#0x40
