; -----------------------------------------------------------------------------
;	蔻菈
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"
		.include	"bgmdriver_h.asm"

		.area	CODE (ABS)
		.globl	player_info
		.globl	enemy_info0
		.globl	enemy_info1
		.globl	enemy_info2
		.globl	enemy_info3
		.globl	enemy_info4
		.globl	enemy_info5
		.globl	shot_info0
		.globl	shot_info1
		.globl	shot_info2
		.globl	eshot_info
		.globl	score_update
		.globl	score_add
		.globl	top_score_check
		.globl	enemy_bomb
		.globl	bgm_clear
		.globl	enemy_boss_destroy_request
		.globl	goto_gameover
		.globl	player_shield
		.globl	player_invincibility
		.globl	background_update_player_info

; -----------------------------------------------------------------------------
;	@蔻
;	input:
;		Ȃ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: GGeɏՓ˂Ă
;	break
;		a, f, b, d, e, ix, iy
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_player_clash::
		; GԂH
		ld		a, (player_invincibility)
		or		a
		ret		nz
		; 蔻
		call	check_player_clash_sub
		ret		nc
		; _[Wo
		ld		hl, #se_bomb
		call	bgmdriver_play_sound_effect
		; @Ƀ_[W^
		ld		a, (player_shield)
		dec		a
		push	af
		ld		(player_shield), a
		call	background_update_player_info
		pop		af
		jp		z, goto_gameover
		ld		a, #30								; _[W󂯂Ǝ@ 0.5bԖGɂȂ
		ld		(player_invincibility), a
		ret

check_player_clash_sub:
		; @ƓG̓蔻
		ld		ix, #player_info
		ld		iy, #enemy_info0
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip1
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip1:

		ld		iy, #enemy_info1
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip2
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip2:

		ld		iy, #enemy_info2
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip3
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip3:

		ld		iy, #enemy_info3
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip4
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip4:

		ld		iy, #enemy_info4
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip5
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip5:

		ld		iy, #enemy_info5
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip6
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip6:

		; @ƓGe̓蔻
		ld		de, #SCA_INFO_SIZE
		ld		b, #15
		ld		iy, #eshot_info
check_player_clash_loop:
		call	check_clash_4x4
		ret		c
		add		iy, de							; オ肵Ȃ CtO = 0
		djnz	check_player_clash_loop			; djnz  CtOs
		ret

; -----------------------------------------------------------------------------
;	G蔻
;	input:
;		Ȃ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: @eɏՓ˂Ă
;	break
;		a, f, b, d, e, h, l, ix, iy
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_enemy_clash::
		ld		hl, (crash_check_routine)
		jp		(hl)

check_enemy_normal_clash::
		ld		ix, #enemy_info0
		ld		b, #6							; G͍őU@
check_enemy_clash_loop1:
		push	bc
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		or		a
		jr		z, check_enemy_clash_skip1		; 쒆łȂGƂ͂蔻肵Ȃ
		ld		iy, #shot_info0
		call	check_clash_12x12
		call	c, enemy_clash
		ld		iy, #shot_info1
		call	check_clash_12x12
		call	c, enemy_clash
		ld		iy, #shot_info2
		call	check_clash_12x12
		call	c, enemy_clash
check_enemy_clash_skip1:
		ld		de, #(SCA_INFO_SIZE * 2)
		add		ix, de
		pop		bc
		djnz	check_enemy_clash_loop1
		ret

; -----------------------------------------------------------------------------
;	{X1蔻
;	input:
;		Ȃ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: @eɏՓ˂Ă
;	break
;		a, f, b, d, e, h, l, ix, iy
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_enemy_boss1_clash:
		ld		ix, #enemy_info0
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		or		a
		jr		z, check_enemy_boss1_clash_skip1		; 쒆łȂGƂ͂蔻肵Ȃ
		ld		iy, #shot_info0
		call	check_clash_boss1
		call	c, enemy_boss1_clash
		ld		iy, #shot_info1
		call	check_clash_boss1
		call	c, enemy_boss1_clash
		ld		iy, #shot_info2
		call	check_clash_boss1
		call	c, enemy_boss1_clash
check_enemy_boss1_clash_skip1:
		ret

; -----------------------------------------------------------------------------
;	GƎ@eՓ˂Ƃ̏
;	input:
;		ix	...	Փ˂G̃AhX
;		iy	...	Փ˂ẽAhX
;	output
;		Ȃ
;	break
;		a, f, b, d, e, h, l
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
enemy_clash:
		; GɃ_[W^
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		sub		SCA_INFO_SHOT_POWER(iy)
		; Gꂽ
		jr		c, enemy_clash_enemy_destroy			; ꂽꍇAG
		jr		z, enemy_clash_enemy_destroy			; ꂽꍇAG
		ld		SCA_INFO_ENEMY_POWER(ix), a				; ϋv͂XV
		; GɃ_[W^𔭐
		ld		hl, #se_damage
		call	bgmdriver_play_sound_effect
		; _ǉ
		ld		de, #0x2								; G_[W 2_
		call	score_add
		call	top_score_check
		call	score_update
enemy_clash_shot_destroy:
		; Փ˂@eł
		ld		SCA_INFO_YH(iy), #212					; \
		ld		SCA_INFO_SHOT_POWER(iy), #0				; ˒łȂ
		ret
		; G
enemy_clash_enemy_destroy:
		; G𔭐
		ld		hl, #se_bomb
		call	bgmdriver_play_sound_effect
		; Փ˂@eł
		ld		SCA_INFO_YH(iy), #212					; \
		ld		SCA_INFO_SHOT_POWER(iy), #0				; ˒łȂ
		; G𔚔p^[ɕύX
		call	enemy_bomb
		; _ǉ
		ld		de, #0x100								; Gj 100_
		call	score_add
		call	top_score_check
		call	score_update
		ret

; -----------------------------------------------------------------------------
;	{XƎ@eՓ˂Ƃ̏
;	input:
;		iy	...	Փ˂ẽAhX
;	output
;		Ȃ
;	break
;		a, f, b, d, e, h, l
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
enemy_boss1_clash:
		ld		ix, #enemy_info0
		; GɃ_[W^
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		sub		SCA_INFO_SHOT_POWER(iy)
		; Gꂽ
		jr		c, enemy_boss1_clash_enemy_destroy			; ꂽꍇAG
		jr		z, enemy_boss1_clash_enemy_destroy			; ꂽꍇAG
		ld		SCA_INFO_ENEMY_POWER(ix), a				; ϋv͂XV
		; GɃ_[W^𔭐
		ld		hl, #se_damage
		call	bgmdriver_play_sound_effect
enemy_boss1_clash_shot_destroy:
		; Փ˂@eł
		ld		SCA_INFO_YH(iy), #212					; \
		ld		SCA_INFO_SHOT_POWER(iy), #0				; ˒łȂ
		ret
		; G
enemy_boss1_clash_enemy_destroy:
		; G𔭐
		ld		hl, #se_bomb
		call	bgmdriver_play_sound_effect
		; Փ˂@eł
		ld		SCA_INFO_YH(iy), #212					; \
		ld		SCA_INFO_SHOT_POWER(iy), #0				; ˒łȂ
		; G𔚔p^[ɕύX
		call	enemy_bomb
		ld		ix, #enemy_info1
		call	enemy_bomb
		ld		ix, #enemy_info2
		call	enemy_bomb
		ld		ix, #enemy_info3
		call	enemy_bomb
		; _ǉ
		ld		de, #0x5000								; {Xj 5000_
		call	score_add
		call	top_score_check
		call	score_update
		; {Xjvs
		call	enemy_boss_destroy_request
		; BGMt~
		call	bgmdriver_stop
		ret

; -----------------------------------------------------------------------------
;	12x12 蔻
;	input:
;		ix	...	ΏۂP
;		iy	...	ΏۂQ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: Փ˂Ă
;	break
;		a, f
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_clash_12x12:
		; A  ABS( ix(SCA_INFO_XH) - iy(SCA_INFO_XH) )
		ld		a, SCA_INFO_XH(ix)
		sub		SCA_INFO_XH(iy)
		jr		nc, check_clash_12x12_skip1
		neg
check_clash_12x12_skip1:
		; if a >= 12 then return
		cp		#12
		ret		nc
		; A  ABS( ix(SCA_INFO_YH) - iy(SCA_INFO_YH) )
		ld		a, SCA_INFO_YH(ix)
		sub		SCA_INFO_YH(iy)
		jr		nc, check_clash_12x12_skip2
		neg
check_clash_12x12_skip2:
		; if a >= 12 then return
		cp		#12
		ret

; -----------------------------------------------------------------------------
;	{X1 蔻
;	input:
;		ix	...	{X
;		iy	...	Vbg
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: Փ˂Ă
;	break
;		a, f
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_clash_boss1:
		; A  ix(SCA_INFO_XH) - iy(SCA_INFO_XH)
		ld		a, SCA_INFO_XH(iy)
		sub		SCA_INFO_XH(ix)
		cp		#-10
		jp		m, check_clash_boss1_no_crash
		cp		#22
		jp		p, check_clash_boss1_no_crash
		; A  ix(SCA_INFO_YH) - iy(SCA_INFO_YH)
		ld		a, SCA_INFO_YH(iy)
		sub		SCA_INFO_YH(ix)
		cp		#-16
		jp		m, check_clash_boss1_no_crash
		cp		#32
		jp		p, check_clash_boss1_no_crash
		scf
		ret
check_clash_boss1_no_crash:
		or		a
		ret

; -----------------------------------------------------------------------------
;	4x4 蔻
;	input:
;		ix	...	ΏۂP
;		iy	...	ΏۂQ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: Փ˂Ă
;	break
;		a, f
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_clash_4x4:
		; A  ABS( ix(SCA_INFO_XH) - iy(SCA_INFO_XH) )
		ld		a, SCA_INFO_XH(ix)
		sub		SCA_INFO_XH(iy)
		jr		nc, check_clash_4x4_skip1
		neg
check_clash_4x4_skip1:
		; if a >= 4 then return
		cp		#4
		ret		nc
		; A  ABS( ix(SCA_INFO_YH) - iy(SCA_INFO_YH) )
		ld		a, SCA_INFO_YH(ix)
		sub		SCA_INFO_YH(iy)
		jr		nc, check_clash_4x4_skip2
		neg
check_clash_4x4_skip2:
		; if a >= 4 then return
		cp		#4
		ret

; -----------------------------------------------------------------------------
;	G蔻胋[`̂ւ
;	input:
;		a	...	蔻胋[`̔ԍ
;				0: ʏ̓G
;				1: {X1
;	output
;		Ȃ
;	break
;		a, f, h, l
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
change_crash_check_routine::
		cp		#1
		jp		c, change_crash_check_routine1
		jp		change_crash_check_routine2

change_crash_check_routine1:
		ld		hl, #check_enemy_normal_clash
		ld		(crash_check_routine), hl
		ret

change_crash_check_routine2:
		ld		hl, #check_enemy_boss1_clash
		ld		(crash_check_routine), hl
		ret

; -----------------------------------------------------------------------------
;	蔻胋[`̃AhX
; -----------------------------------------------------------------------------
crash_check_routine:
		.dw		#enemy_clash

; -----------------------------------------------------------------------------
;	ʉf[^
; -----------------------------------------------------------------------------
se_damage::
		.db		#BGM_SE_VOL
		.db		#12
		.db		#BGM_SE_FREQ
		.dw		#30
		.db		#BGM_SE_NOISE_FREQ
		.db		#0 + 0x80
		.db		#BGM_SE_WAIT
		.db		#1
		.db		#BGM_SE_VOL
		.db		#8
		.db		#BGM_SE_FREQ
		.dw		#28
		.db		#BGM_SE_WAIT
		.db		#1
		.db		#BGM_SE_VOL
		.db		#4
		.db		#BGM_SE_FREQ
		.dw		#26
		.db		#BGM_SE_WAIT
		.db		#1
		.db		#BGM_SE_VOL
		.db		#2
		.db		#BGM_SE_FREQ
		.dw		#24
		.db		#BGM_SE_WAIT
		.db		#1
		.db		#BGM_SE_END

se_bomb::
		.db		#BGM_SE_VOL
		.db		#12
		.db		#BGM_SE_FREQ
		.dw		#32768				; 32768 ɂ TONE OFF
		.db		#BGM_SE_NOISE_FREQ
		.db		#20 + 0x80
		.db		#BGM_SE_WAIT
		.db		#5
		.db		#BGM_SE_NOISE_FREQ
		.db		#8 + 0x80
		.db		#BGM_SE_WAIT
		.db		#5
		.db		#BGM_SE_NOISE_FREQ
		.db		#28 + 0x80
		.db		#BGM_SE_WAIT
		.db		#5
		.db		#BGM_SE_NOISE_FREQ
		.db		#12 + 0x80
		.db		#BGM_SE_WAIT
		.db		#5
		.db		#BGM_SE_NOISE_FREQ
		.db		#31 + 0x80
		.db		#BGM_SE_WAIT
		.db		#10
		.db		#BGM_SE_NOISE_FREQ
		.db		#15 + 0x80
		.db		#BGM_SE_WAIT
		.db		#10
		.db		#BGM_SE_END
