; -----------------------------------------------------------------------------
;	SCA public definition
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
;	\
; -----------------------------------------------------------------------------
SCA_INFO_SIZE					= 8

SCA_INFO_XL						= 0
SCA_INFO_XH						= 1
SCA_INFO_YL						= 2
SCA_INFO_YH						= 3
SCA_INFO_PLAYER_MOVE_VEC_TBL_L	= 4
SCA_INFO_PLAYER_MOVE_VEC_TBL_H	= 5
SCA_INFO_PLAYER_SHOT_POWER		= 6

SCA_INFO_SHOT_POWER				= 4

SCA_INFO_ENEMY_REVERSE			= 0
SCA_INFO_ENEMY_SHOT_TIMING		= 2
SCA_INFO_ENEMY_POWER			= 4
SCA_INFO_ENEMY_STATE_L			= 5
SCA_INFO_ENEMY_STATE_H			= 6
SCA_INFO_ENEMY_SPRITE_NUM		= 7
SCA_INFO_ENEMY_STATE_L2			= 12
SCA_INFO_ENEMY_STATE_H2			= 13
SCA_INFO_ENEMY_MOVE_L			= 14
SCA_INFO_ENEMY_MOVE_H			= 15

SCA_INFO_ESHOT_X_SIG			= 0
SCA_INFO_ESHOT_Y_SIG			= 2
SCA_INFO_ESHOT_DEN_IS_DX		= 4
SCA_INFO_ESHOT_DEN				= 5
SCA_INFO_ESHOT_NUM				= 6
SCA_INFO_ESHOT_CNT				= 7

SCA_INFO_XL2					= 0 + SCA_INFO_SIZE
SCA_INFO_XH2					= 1 + SCA_INFO_SIZE
SCA_INFO_YL2					= 2 + SCA_INFO_SIZE
SCA_INFO_YH2					= 3 + SCA_INFO_SIZE

SCA_INFO_XL3					= 0 + SCA_INFO_SIZE * 2
SCA_INFO_XH3					= 1 + SCA_INFO_SIZE * 2
SCA_INFO_YL3					= 2 + SCA_INFO_SIZE * 2
SCA_INFO_YH3					= 3 + SCA_INFO_SIZE * 2

SCA_INFO_XL4					= 0 + SCA_INFO_SIZE * 3
SCA_INFO_XH4					= 1 + SCA_INFO_SIZE * 3
SCA_INFO_YL4					= 2 + SCA_INFO_SIZE * 3
SCA_INFO_YH4					= 3 + SCA_INFO_SIZE * 3

SCA_INFO_XL5					= 0 + SCA_INFO_SIZE * 4
SCA_INFO_XH5					= 1 + SCA_INFO_SIZE * 4
SCA_INFO_YL5					= 2 + SCA_INFO_SIZE * 4
SCA_INFO_YH5					= 3 + SCA_INFO_SIZE * 4

SCA_INFO_XL6					= 0 + SCA_INFO_SIZE * 5
SCA_INFO_XH6					= 1 + SCA_INFO_SIZE * 5
SCA_INFO_YL6					= 2 + SCA_INFO_SIZE * 5
SCA_INFO_YH6					= 3 + SCA_INFO_SIZE * 5

SCA_INFO_XL7					= 0 + SCA_INFO_SIZE * 6
SCA_INFO_XH7					= 1 + SCA_INFO_SIZE * 6
SCA_INFO_YL7					= 2 + SCA_INFO_SIZE * 6
SCA_INFO_YH7					= 3 + SCA_INFO_SIZE * 6

SCA_INFO_XL8					= 0 + SCA_INFO_SIZE * 7
SCA_INFO_XH8					= 1 + SCA_INFO_SIZE * 7
SCA_INFO_YL8					= 2 + SCA_INFO_SIZE * 7
SCA_INFO_YH8					= 3 + SCA_INFO_SIZE * 7

; -----------------------------------------------------------------------------
;	萔
; -----------------------------------------------------------------------------
SCA_SHOT_COUNT					= 15			; G̒e̍őo(15܂)
SCA_MAX_ENEMY_POWER				= 32			; URG̍d̍ől
SCA_MIN_ENEMY_SHOT_INTERVAL		= 4				; URG̒ěԊuŏl

; -----------------------------------------------------------------------------
;	BIOS entry
; -----------------------------------------------------------------------------
SETWRT							= 0x0053
FILVRM							= 0x0056
LDIRVM							= 0x005C
CHGMOD							= 0x005F
GTSTCK							= 0x00D5
GTTRIG							= 0x00D8

; -----------------------------------------------------------------------------
;	BIOS workarea
; -----------------------------------------------------------------------------
RG1SAV							= 0xF3E0
STATFL							= 0xF3E7
FORCLR							= 0xF3E9
BAKCLR							= 0xF3EA
BDRCLR							= 0xF3EB

; -----------------------------------------------------------------------------
;	BIOS hook
; -----------------------------------------------------------------------------
H_TIMI							= 0xFD9F

; -----------------------------------------------------------------------------
;	I/O port
; -----------------------------------------------------------------------------
VDP_VRAM_IO						= 0x98
VDP_CMDREG_IO					= 0x99
VDP_PALREG_IO					= 0x9A
VDP_REG_IO						= 0x9B

; -----------------------------------------------------------------------------
;	VRAM map (SCREEN4)
; -----------------------------------------------------------------------------
PATTERN_GENERATOR1				= 0x0000
PATTERN_GENERATOR2				= 0x0800
PATTERN_GENERATOR3				= 0x1000
PATTERN_NAME1					= 0x1800
PATTERN_NAME2					= 0x1900
PATTERN_NAME3					= 0x1A00
SPRITE_COLOR					= 0x1C00
SPRITE_ATTRIBUTE				= 0x1E00
COLOR_TABLE1					= 0x2000
COLOR_TABLE2					= 0x2800
COLOR_TABLE3					= 0x3000
SPRITE_GENERATOR				= 0x3800
